# Allow target distro to be overridden using: rpmbuild --define "distro fc3"
# Valid values for distro are: fc3 fc4 fc5 fc6 fc7 fc8 fc9 fc10 fc11 fc12 fc13 fc14 fc15 fc16 fc17 fc18 fc19 fc20 fc21 fc22 fc23 fc24 devel rhel3 rhel4 rhel5 rhel6 rhel7

# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# For the special case of Rawhide, use "devel" as the distro
%if "%{__distname}" == "Rawhide"
%global __distvers %{nil}
%global __distinit devel
%endif
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Set distribution booleans
# Note that distributions older than FC3/RHEL4 aren't actually supported due to
# the yum version requirement
%{!?distro: %global distro %{__distinit}%{__distvers}}
%global rhl7	%(if [ "%{distro}" == "rhl7"	]; then echo 1; else echo 0; fi)
%global rhl8	%(if [ "%{distro}" == "rhl8"	]; then echo 1; else echo 0; fi)
%global rhl9	%(if [ "%{distro}" == "rhl9"	]; then echo 1; else echo 0; fi)
%global rhel3	%(if [ "%{distro}" == "rhel3"	]; then echo 1; else echo 0; fi)
%global rhel4	%(if [ "%{distro}" == "rhel4"	]; then echo 1; else echo 0; fi)
%global rhel5	%(if [ "%{distro}" == "rhel5"	]; then echo 1; else echo 0; fi)
%global rhel6	%(if [ "%{distro}" == "rhel6"	]; then echo 1; else echo 0; fi)
%global rhel7	%(if [ "%{distro}" == "rhel7"	]; then echo 1; else echo 0; fi)
%global fc1	%(if [ "%{distro}" == "fc1"	]; then echo 1; else echo 0; fi)
%global fc2	%(if [ "%{distro}" == "fc2"	]; then echo 1; else echo 0; fi)
%global fc3	%(if [ "%{distro}" == "fc3"	]; then echo 1; else echo 0; fi)
%global fc4	%(if [ "%{distro}" == "fc4"	]; then echo 1; else echo 0; fi)
%global fc5	%(if [ "%{distro}" == "fc5"	]; then echo 1; else echo 0; fi)
%global fc6	%(if [ "%{distro}" == "fc6"	]; then echo 1; else echo 0; fi)
%global fc7	%(if [ "%{distro}" == "fc7"	]; then echo 1; else echo 0; fi)
%global fc8	%(if [ "%{distro}" == "fc8"	]; then echo 1; else echo 0; fi)
%global fc9	%(if [ "%{distro}" == "fc9"	]; then echo 1; else echo 0; fi)
%global fc10	%(if [ "%{distro}" == "fc10"	]; then echo 1; else echo 0; fi)
%global fc11	%(if [ "%{distro}" == "fc11"	]; then echo 1; else echo 0; fi)
%global fc12	%(if [ "%{distro}" == "fc12"	]; then echo 1; else echo 0; fi)
%global fc13	%(if [ "%{distro}" == "fc13"	]; then echo 1; else echo 0; fi)
%global fc14	%(if [ "%{distro}" == "fc14"	]; then echo 1; else echo 0; fi)
%global fc15	%(if [ "%{distro}" == "fc15"	]; then echo 1; else echo 0; fi)
%global fc16	%(if [ "%{distro}" == "fc16"	]; then echo 1; else echo 0; fi)
%global fc17	%(if [ "%{distro}" == "fc17"	]; then echo 1; else echo 0; fi)
%global fc18	%(if [ "%{distro}" == "fc18"	]; then echo 1; else echo 0; fi)
%global fc19	%(if [ "%{distro}" == "fc19"	]; then echo 1; else echo 0; fi)
%global fc20	%(if [ "%{distro}" == "fc20"	]; then echo 1; else echo 0; fi)
%global fc21	%(if [ "%{distro}" == "fc21"	]; then echo 1; else echo 0; fi)
%global fc22	%(if [ "%{distro}" == "fc22"	]; then echo 1; else echo 0; fi)
%global fc23	%(if [ "%{distro}" == "fc23"	]; then echo 1; else echo 0; fi)
%global fc24	%(if [ "%{distro}" == "fc24"	]; then echo 1; else echo 0; fi)
%global devel	%(if [ "%{distro}" == "devel"	]; then echo 1; else echo 0; fi)

Summary:	Release file and package configuration for city-fan.org repository
Name:		city-fan.org-release
Version:	1
Release:	12.%{distro}
License:	GPLv2+
URL:		http://www.city-fan.org/ftp/contrib/yum-repo/
Group:		System Environment/Base
Source0:	GPL
Source1:	RPM-GPG-KEY-city-fan.org
Source2:	city-fan.org.repo
Source3:	city-fan.org-development.repo
Requires:	yum >= 2.2.1
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch

%description
city-fan.org release file. This package also contains yum configuration to
use the city-fan.org provided rpm packages, as well as the public gpg key
used to sign them.

%prep
%setup -c -T
cp -a %{SOURCE0} %{SOURCE1} .
%if %{devel}
cp -a %{SOURCE3} city-fan.org.repo
%else
cp -a %{SOURCE2} city-fan.org.repo
%endif
%if %{fc3} || %{rhel4}
sed -i -e 's@/etc/pki/rpm-gpg/@%{_defaultdocdir}/%{name}-%{version}/@g' city-fan.org.repo
%endif
%if %{fc3} || %{fc4} || %{fc5} || %{fc6}
sed -i -e 's/Fedora/Fedora Core/' city-fan.org.repo
%endif
%if %{rhel4} || %{rhel5} || %{rhel6} || %{rhel7}
sed -i -e 's@\([-/]\)fc\$@\1rhel$@' city-fan.org.repo
sed -i -e 's@Fedora@Red Hat Enterprise Linux (and clones)@' city-fan.org.repo
%endif

%build

%install
rm -rf %{buildroot}

# Install gpg key (it's %%doc in fc3 and rhel4)
%if ! %{fc3} && ! %{rhel4}
install -m 0755 -d %{buildroot}%{_sysconfdir}/pki/rpm-gpg
install -m 0644 RPM-GPG-KEY-city-fan.org %{buildroot}%{_sysconfdir}/pki/rpm-gpg/
%endif

# Install repo files
install -D -m 0644 city-fan.org.repo \
	%{buildroot}%{_sysconfdir}/yum.repos.d/city-fan.org.repo

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc GPL
%if %{fc3} || %{rhel4}
%doc RPM-GPG-KEY-city-fan.org
%else
%config(noreplace) %{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-city-fan.org
%endif
%pubkey RPM-GPG-KEY-city-fan.org
%config(noreplace) %{_sysconfdir}/yum.repos.d/city-fan.org.repo

%changelog
* Fri Sep 21 2012 Paul Howarth <paul@city-fan.org> 1-12
- add debuginfo and source repositories
- support Fedora releases up to 24
- merge the regular and development repo configurations and ship only the
  former, even on Rawhide

* Fri Jul 29 2011 Paul Howarth <paul@city-fan.org> 1-10
- update GPLv2 text for FSF address change
- fix dist tag for CentOS 6 and Scientific Linux
- nobody else likes macros for commands

* Fri Feb 11 2011 Paul Howarth <paul@city-fan.org> 1-9
- support Fedora releases up to 20

* Mon Jun  8 2009 Paul Howarth <paul@city-fan.org> 1-8
- use setup macro in %%prep to run in a subdir

* Tue May 19 2009 Paul Howarth <paul@city-fan.org> 1-7
- define macros in global context
- only refer to "Fedora Core" for releases prior to Fedora 7

* Fri Mar 23 2007 Paul Howarth <paul@city-fan.org> 1-6
- add CentOS 5 support and look forward to future releases
- add empty %%build section

* Mon Jan  8 2007 Paul Howarth <paul@city-fan.org> 1-5
- add CentOS 4 support (same as FC3)

* Tue Oct 31 2006 Paul Howarth <paul@city-fan.org> 1-4
- add Fedora Core 6 and Rawhide support
- include architecture in baseurls

* Tue Mar 21 2006 Paul Howarth <paul@city-fan.org> 1-3
- add Fedora Core 5 support
- update distribution-detection code
- remove buildroot unconditionally in %%clean and %%install

* Thu Jul 14 2005 Paul Howarth <paul@city-fan.org> 1-2
- use gpgkey= in city-fan.org.repo and require yum >= 2.2.1
- don't auto-import GPG key in %%post
- make fc3 and fc4 specific versions of package (different gpg key locations)

* Mon Nov 15 2004 Paul Howarth <paul@city-fan.org> 1-1
- initial RPM release, inspired by fedora-release
